#!/usr/bin/perl
use strict;

my $gbfile = $ARGV[ 0]; #"Arabidopsis_thaliana.mRNA.PLN.fasta";
#$gbfile1 = "sequencemicro.fasta";
my $mifile = $ARGV[ 1]; #"Imm1_12U_Uforce.csv";
#my $gboutfile = "result.csv";
my $gboutfile = $ARGV[ 2];
my $switch = $ARGV[ 3];
my $switchU = $ARGV[ 4];

my $num_args = $#ARGV + 1;
if ($num_args != 5) {
  print "\nUsage: 'amick.pl file_with_targets.fasta file_with_artificial_miRNA.csv output_filename.csv' with one of the following parameters +a or -a and +u or -u' \n";
  exit;
}

open OUT, ">$gboutfile" or die "Can't open $gboutfile: $!";

print "Nazwa pliku: $gboutfile\n";

my @genome;
my @name;
my $indexGenome = -1;
#$miRNA = "AGCAACAACCAACTCTCAAGA";
my $miRNA = "TTGCAAGCGTGATCTCTTCAG";#"TTGCAAGCCTGATCTCTTCAG";#CTGAAGAGATCAGGCTTGCAA


my %miRNA;
my %amiRNA;
my $indexMIRNA = -1;
my $indexAMIRNA = -1;

# get miRNA from file
read_micro_file();

# get targets from file
read_target_file();

foreach my $key (keys %miRNA){
	#print "$key $miRNA{$key}\n";
}
#print "\n";
foreach my $key (keys %amiRNA){
	#print "$key $amiRNA{$key}\n";
}


my $index = 0;

#foreach $target (@genome) {
for (my $t = 0; $t < scalar(@genome); ++$t) {
	#$target = $genome[0];
	#$target=~ tr/A-Z/a-z/;	
	#print "Target $name[$index++]\n";
	foreach my $key (keys %miRNA){ 
		#print "\n$key\n";
		scan_target_with_miRNA($t, $miRNA{$key}, $key);	
	}
	if ($switch eq "+a") {
		foreach my $key (keys %amiRNA){ 
			#print "\n$key\n";
			scan_target_with_miRNA($t, $amiRNA{$key}, $key);	
		}
	}

}

sub scan_target_with_miRNA (){
	my $miRNA = $_[1];
	$genome[$_[0]]=~ tr/A-Z/a-z/;
	$genome[$_[0]]=~ tr/t/u/;
	#print "$genome[$t]\n\n";
	my @nucleotideTarget = split /\s*/,$genome[$_[0]];#$genome[0];#$target;
	#print "$nucleotideTarget[0]\n";
	$miRNA=~ tr/A-Z/a-z/;
	$miRNA=~ tr/t/u/;
	#print "\n$miRNA\n";
	my $miRNA1 = $miRNA;
	$miRNA = reverse_complement($miRNA);	
	my @nucleotideRNA = split /\s*/,$miRNA;
	#print "$miRNA\n";
	for (my $i = 0; $i < scalar(@nucleotideTarget); ++$i) {
		my $errL = 0;
		my $errU = 0;
		my $ind = $i; 
		my $errInd = 0;
		my @errTab;
		for (my $j = 0; $j < scalar(@nucleotideRNA); ++$j) {
#			#print "$nucleotideTarget[$ind]";
			if ($nucleotideTarget[$ind] ne $nucleotideRNA[$j]){
				#print "$nucleotideTarget[$i] ne $nucleotideRNA[$j]\n";
				$errTab[$errInd++] = length($miRNA)-$j;				
				#++$err;
				if (($errTab[$errInd-1] == 11) || ($errTab[$errInd-1] == 2) || ($errTab[$errInd-1] == 10) || ($errTab[$errInd-1] == 12)) {$errL=4;last;} #nie pozycja 11, 10, 1, 2, 12
				if ($errTab[$errInd-1] < 10){ #od 3-10 tylko 1 blad max
					if ($errTab[$errInd-1] == 1) {
						if ($switchU eq "+u") {--$errL;}
					}
					++$errL;
					if ($errL > 1) {$errL=4;last;}
				} 
				if ($errTab[$errInd-1] >= 13){
					++$errU;
					if ($errU-1 > 0){ #nie po kolei
						if ($errTab[$errInd-2] - 1 == $errTab[$errInd-1]) {$errU=4;last;}
					}
					if ($errU > 2) {$errU=4;last;} # max 2 MM
				} 
				if (($errL + $errU) > 3) {last;}
			}
			++$ind;
		}	
#		print "\n";
#		print "$miRNA\n\n";
		my $err = $errL + $errU;
		if ($err <= 3) {
			#print "Target Pasuje $i $nucleotideTarget[$i] $name[$_[0]]\n"; 
			print OUT "$_[2];$name[$_[0]];";
			
			#print "\n$miRNA\n";
			print OUT "$miRNA1;";
			for (my $t = $i; $t < $i+length($miRNA); ++$t) {
			#	print $nucleotideTarget[$t];
				print OUT "$nucleotideTarget[$t]";
			}
			print OUT ";";
			for (my $t1 = 0; $t1 < $err; ++$t1) {
			#	print "$errTab[$t1] ";
				print OUT "$errTab[$t1] ";
			}
			#print "\n$miRNA1\n";
			print OUT "\n";
			
		}
	}
}

sub reverse_complement () {
	my $new = $_[0];
	#$new =~ tr/acgtu/tgcaa/;
	$new =~ tr/acgu/ugca/;
	$new = reverse ($new);
	return ($new); 
}

sub read_micro_file() {
 open(MI, $mifile) or die "Can't open $mifile: $!";
 my $info = <MI>;
 while (<MI>) {
	chomp($_);
	#printf "$_\n";
	my @x = split /;/,$_;
	#print "$x[0] $x[1] $x[2] $x[3]";
	$miRNA{$x[0]} = $x[1];	
	if ($switch eq "+a") {$amiRNA{$x[2]} = $x[3];	}
 }
 close(MI);
}

sub read_target_file() {
 open(GB, $gbfile) or die "Can't open $gbfile: $!";
 while (<GB>) {
	chomp($_);
	if (!(/^>/i)) {
		$genome[$indexGenome] .= $_;
	} else {		
		++$indexGenome;
		$genome[$indexGenome] = "";
#		if ($indexGenome - 1 >= 0) {print "$genome[$indexGenome-1] \n\n";}
		$name[$indexGenome] = $_;
		$name[$indexGenome] =~s/>//g;
#		print "$_\n$name[$indexGenome]";
	}
 }
 close(GB);
}


